
import queue
import icons



def show_msg(hexi,*args):
    """
      lines= 0 indica status bar
    """
    line_msg=55
    for ar in args:
        hexi.draw_text(ar,0, line_msg, 96, 15, align=3, color=0xFFFF, background=0x0000, encode=False)
        line_msg-=20
    return
        

def cita(hexi,msg):
    show_msg(hexi,msg,"Tomar")

def activ(hexi,msg):
    show_msg(hexi,msg,"Actividad")
    
def med(hexi,msg):
    show_msg(hexi,msg,"Medico")    

def GSM_Con(hexi,*args):
    show_msg(hexi,"Red GSM","Conectando")
    

def GSM_UP(hexi,*args):
    hexi.draw_text("GSM",0, 0,10,10, align=3, color=0xFFFF, background=0x0000, encode=False)


def CLOUD_UP(hexi,*args):
    hexi.draw_text("CLOUD",60, 0,90,10, align=3, color=0xFFFF, background=0x0000, encode=False)

def Time_Now(hexi,*args):
    show_msg(hexi,"httpbin.org","Request hora")

def Bateria(hexi, nivel):
    largo_barra = int(nivel)-4
    if largo_barra < 15:
        hexi.draw_text("BATERIA BAJA",0, 80,96,15, align=3, color=0xFFFF, background=0xF800, encode=False)
    else:
        hexi.draw_text("Bateria",0, 80,96,11, align=1, color=0xFFFF, background=0x0000, encode=False)
        hexi.fill_rect(0,92,96,4,0x0000, encode=False)
        #sleep(200)
        hexi.fill_rect(0,92,largo_barra,4,0xDEC0, encode=False) if largo_barra < 60 else hexi.fill_rect(0,92,largo_barra,4,0x07E0, encode=False)
    
def MQTT_Con(hexi,*args):
    show_msg(hexi,"IBMCloud IoT","Conectando..")
             
    
def Tech_Fail(hexi,*args):
    hexi.clear_display()
    show_msg(hexi,"AVERIA!!!")
    hexi.draw_image(icons.Tools, 22, 10, 50, 50)
    sleep(10000)
    
def Temp_Low(hexi,*args):
    hexi.fill_rect(0,11,96,70,0x0000, encode=False)
    hexi.draw_text("FRIO!!!",0, 55, 96, 26, align=3, color=0xFFFF, background=0x0000, encode=False)
    #show_msg(hexi,"Frio!!!")
    hexi.draw_image(icons.Snow, 22, 10, 50, 50)
    
def Temp_High(hexi,*args):
    hexi.fill_rect(0,11,96,70,0x0000, encode=False)
    hexi.draw_text("CALOR!!!",0, 55, 96, 26, align=3, color=0xFFFF, background=0x0000, encode=False)
    hexi.draw_image(icons.SunHot, 22, 10, 50, 50)

def Clock(hexi,hora):
    hexi.draw_text(hora,0, 15, 96, 60, align=3, color=0xFFFF, background=0x0000, encode=False)
    
def main_thread(fifo_screen,hexi):
    on_screen = []  
    
    method_dict = {
        'GSM_Con': GSM_Con,
        'GSM_UP': GSM_UP,
        'CLOUD_UP': CLOUD_UP,
        'Time_Now': Time_Now,
        'MQTT_Con': MQTT_Con,
        'Tech_Fail': Tech_Fail,
        'Temp_Low': Temp_Low,
        'Temp_High': Temp_High,
        'Clock': Clock,
        'cita' : cita,
        'med' : med,
        'activ': activ,
        'Bateria': Bateria
        
    }
    
    while True:
        try:
            next_screen = fifo_screen.get()
            on_screen.append(next_screen) if not next_screen in on_screen else  on_screen.remove(next_screen)
        except Exception as e:
            print(e)
        for exe_method in on_screen:
            method_dict[exe_method[0]](hexi,exe_method[1])
            if exe_method[0] =='Bateria' or exe_method[0] =='cita' or exe_method[0] =='med' or exe_method[0] =='activ':
                on_screen.remove(exe_method)
        sleep(2000)
  
